% template_sz is width x height
function prob = compare_histogram_with_integral_histogram(img, int_hist, hist_model, template_sz);

prob = zeros(size(img,1), size(img,2));

if any(mod(template_sz,2) ~= 1), assert('size of rect must be odd'), end
hsz = (template_sz-1) / 2;

% col1 = img(:,:,1);
% col2 = img(:,:,2);
% col3 = img(:,:,3);
% 
% binwidth1 = 256/nbins(1);
% binwidth2 = 256/nbins(2);
% binwidth3 = 256/nbins(3);
% 
% int_hist = zeros(prod(size(img)), prod(nbins));
% 
% im1 = col1(:);
% im2 = col2(:);
% im3 = col3(:);
% indx1 = floor( im1 / binwidth1 ) + 1;
% indx2 = floor( im2 / binwidth2 ) + 1;
% indx3 = floor( im3 / binwidth3 ) + 1;
% if any(indx1<1 | indx1>nbins(1)), error('assert'), end
% if any(indx2<1 | indx2>nbins(2)), error('assert'), end
% if any(indx3<1 | indx3>nbins(3)), error('assert'), end

%i = 1;
height = size(img, 1);
for c = hsz(1)+1 : size(img,2)-hsz(1)
    for r = hsz(2)+1 : size(img,1)-hsz(2)
        q_tl = GetIndex(r-hsz(2), c-hsz(1), height);
        q_tr = GetIndex(r-hsz(2), c+hsz(1), height);
        q_bl = GetIndex(r+hsz(2), c-hsz(1), height);
        q_br  = GetIndex(r+hsz(2), c+hsz(1), height);
        hist = int_hist(q_tl,:) + int_hist(q_br,:) - int_hist(q_bl,:) - int_hist(q_tr,:);
        prob(r,c) = sum( min(hist, hist_model) );  % histogram intersection
%        i = i + 1;
    end
end

function indx = GetIndex(r, c, height)
indx = (c-1)*height + r;

%function indx = GetHistIndx(indx1, indx2, indx3, nbins)
%indx = (indx1-1) * (nbins(2)*nbins(3)) + (indx2-1) * (nbins(3)) + indx3;
