function hist = compute_color_histogram(im, nbins, rect)

binwidth1 = 256/nbins(1);
binwidth2 = 256/nbins(2);
binwidth3 = 256/nbins(3);

hist = zeros(1, prod(nbins));

for c=rect(1):rect(3),
    for r=rect(2):rect(4),
        
        indx1 = floor( im(r,c,1) / binwidth1 ) + 1;
		indx2 = floor( im(r,c,2) / binwidth2 ) + 1;
		indx3 = floor( im(r,c,3) / binwidth3 ) + 1;
		if any(indx1<1 | indx1>nbins(1)), error('assert'), end
		if any(indx2<1 | indx2>nbins(2)), error('assert'), end
		if any(indx3<1 | indx3>nbins(3)), error('assert'), end

        j = GetHistIndx(indx1, indx2, indx3, nbins);
        hist(j) = hist(j) + 1;
    end
end

function indx = GetHistIndx(indx1, indx2, indx3, nbins)
indx = (indx1-1) * (nbins(2)*nbins(3)) + (indx2-1) * (nbins(3)) + indx3;
