function shift = compute_meanshift_vector(hist_cand, hist_model, img, state, aspect_ratio, nbins)

if any(size(hist_cand)~=size(hist_model)), error('histograms must be same size'), end

% center point
r0 = state(1);
c0 = state(2);
    
% color planes
col1 = img(:,:,1);
col2 = img(:,:,2);
col3 = img(:,:,3);

% get ellipse mask
[perim, mask] = generate_ellipse(size(img), state, aspect_ratio);

minval = 1 / prod(nbins);
%[max(max(max(hist_cand))) minval]
%[max(max(max(hist_model))) minval]
binwidth1 = 256/nbins(1);
binwidth2 = 256/nbins(2);
binwidth3 = 256/nbins(3);
shift = [0 0];
wtot = 0;
for r=1:size(img,1)
    for c=1:size(img,2)
        if (mask(r, c) == 1)
            indx1 = floor( col1(r,c) / binwidth1 ) + 1;
            indx2 = floor( col2(r,c) / binwidth2 ) + 1;
            indx3 = floor( col3(r,c) / binwidth3 ) + 1;
			pval = hist_cand(indx1, indx2, indx3);
%            pval = max(pval, minval);
			qval = hist_model(indx1, indx2, indx3);
            if pval<0 | qval<0, error('assert'), end
            if pval>minval & qval>minval,
				wi = sqrt(qval / pval);            
                shift = shift + wi * [r-r0, c-c0];  % if not Epanechnikov profile, then multiply by k', too
                wtot = wtot + wi;
            end
        end
    end
end

shift = shift / wtot;