function shift = compute_meanshift_vector_spatiogram(spat_cand, spat_model, img, state, aspect_ratio, nbins)

% set this to one to disallow all spatiogram-specific parts of the
% computation
global just_do_histogram

hist_cand = spat_cand.histogram;
hist_model = spat_model.histogram;

if any(size(hist_cand)~=size(hist_model)), error('histograms must be same size'), end

% center point
r0 = state(1);
c0 = state(2);
    
% color planes
col1 = img(:,:,1);
col2 = img(:,:,2);
col3 = img(:,:,3);

% get ellipse mask
[perim, mask] = generate_ellipse(size(img), state, aspect_ratio);

minval = 1 / prod(nbins);
%[max(max(max(hist_cand))) minval]
%[max(max(max(hist_model))) minval]
binwidth1 = 256/nbins(1);
binwidth2 = 256/nbins(2);
binwidth3 = 256/nbins(3);
shift = [0 0];
atot = 0;
vbtot = 0;  % just for testing
bin_has_been_visited = zeros(size(hist_cand));
if just_do_histogram,
%    disp('ok')
    bin_has_been_visited = bin_has_been_visited + 1;
end
for r=1:size(img,1)
    for c=1:size(img,2)
        if (mask(r, c) == 1)
            indx1 = floor( col1(r,c) / binwidth1 ) + 1;
            indx2 = floor( col2(r,c) / binwidth2 ) + 1;
            indx3 = floor( col3(r,c) / binwidth3 ) + 1;
			pval = hist_cand(indx1, indx2, indx3);
			qval = hist_model(indx1, indx2, indx3);
            mupc = spat_cand.mean_c(indx1, indx2, indx3);
            mupr = spat_cand.mean_r(indx1, indx2, indx3);
            muqc = spat_model.mean_c(indx1, indx2, indx3);
            muqr = spat_model.mean_r(indx1, indx2, indx3);
            varpc = spat_cand.var_c(indx1, indx2, indx3);
            varpr = spat_cand.var_r(indx1, indx2, indx3);
            varqc = spat_model.var_c(indx1, indx2, indx3);
            varqr = spat_model.var_r(indx1, indx2, indx3);
            if pval<0 | qval<0, error('assert'), end
            if pval>minval & qval>minval,
				wi = sqrt(qval / pval);       
                invvarc = 1/varpc + 1/varqc;
                invvarr = 1/varpr + 1/varqr;
                psi_b = exp(-0.5 * (((mupc-muqc)^2) * invvarc + ((mupr-muqr)^2) * invvarr));
                ch = 2 / pi;  % only for an Epanechnikov kernel profile in 2D
                h = state(3);  % this looks wrong to me, but it's the best I can do for now
                if just_do_histogram,
                    alpha_i = wi;
                else
                    alpha_i = (ch / h^2) * psi_b * wi;
                end
                shift = shift + alpha_i * [r-r0, c-c0];  % if not Epanechnikov profile, then multiply by k', too
                if bin_has_been_visited(indx1, indx2, indx3)==0,
                    vb = psi_b * sqrt(pval * qval) * [(muqc-mupc) * invvarc, (muqr-mupr) * invvarr];
%                    disp([alpha_i norm(vb)])
                    shift = shift + vb;
                    bin_has_been_visited(indx1, indx2, indx3) = 1;
                    vbtot = vbtot + norm(vb);  % just for testing
                end
                atot = atot + alpha_i;
            end
        end
    end
end

shift = shift / atot;

%disp([atot vbtot])