
function img_color = colspace(img,select)
% colspace converts image from one color space to a required color space.
%if select = 0, do not change colorspace,ie colorspace = RGB.
if select == 0,
    col1 = img(:,:,1);
    col2 = img(:,:,2);
    col3 = img(:,:,3);

    
    
    img_color(:,:,1) = col1;
    img_color(:,:,2) = col2;
    img_color(:,:,3) = col3;
end

% If select = 1, conversion from RGB to CVPR_98 Color space.

if select == 1,
    col3 = (img(:,:,1)+ img(:,:,2) + img(:,:,3))/3; 
    col1 = ((img(:,:,3) - img(:,:,2)) * 10 ) + 127;
    col2 = ((img(:,:,2) - img(:,:,1)) * 10 ) + 127;
    
    col1 = max(min(col1, 255), 0);
    col2 = max(min(col2, 255), 0);
    col3 = max(min(col3, 255), 0);
    
    
    img_color(:,:,1) = col1;
    img_color(:,:,2) = col2;
    img_color(:,:,3) = col3;
end

% if select =2, conversion from RGB to YUV.
if select == 2,
    col1 = 0.299*(img(:,:,1)) + 0.587*(img(:,:,2)) + 0.114*(img(:,:,3));
    col2 = (0.147*(img(:,:,1)) - 0.289*(img(:,:,2)) + 0.436*(img(:,:,3)))*10 + 127;
    col3 = (0.618*(img(:,:,1)) - 0.515*(img(:,:,2)) - 0.1*(img(:,:,3)))*10 + 127;

    
    col1 = max(min(col1, 255), 0);
    col2 = max(min(col2, 255), 0);
    col3 = max(min(col3, 255), 0);
    
    
    img_color(:,:,1) = col1;
    img_color(:,:,2) = col2;
    img_color(:,:,3) = col3;
    
end


%if select = 3, conversion from RGB to HSV. uses Matlab's inbuilt function.
if select == 3
    img1 = rgb2hsv(img);
    col1 = img1(:,:,1) *255;
    col2 = img1(:,:,2)*255;
    col3 = img1(:,:,3);
    
%     col1 = max(min(col1, 255), 0);
%     col2 = max(min(col2, 255), 0);
%     col3 = max(min(col3, 255), 0);
    
    img_color(:,:,1) = col1;
    img_color(:,:,2) = col2;
    img_color(:,:,3) = col3;
    
    
end


