function similarity = compare_spatiograms(spat1, spat2)

spat_n1 = max(spat1.histogram(:), 1);  % prevents divide by zero; won't affect results
spat_meanx1 = spat1.sumx(:) ./ spat_n1;
spat_meany1 = spat1.sumy(:) ./ spat_n1;
spat_varx1 = spat1.sumx2(:) ./ spat_n1 - spat_meanx1.^2;
spat_vary1 = spat1.sumy2(:) ./ spat_n1 - spat_meany1.^2;
spat_varx1 = max(spat_varx1, 1);
spat_vary1 = max(spat_vary1, 1);
%spat_mean1 = [spat_meanx1 spat_meany1]';
%covinv1 = [1/spat_varx1 0 ; 0 1/spat_vary1];

spat_n2 = max(spat2.histogram(:), 1);  % prevents divide by zero; won't affect results
spat_meanx2 = spat2.sumx(:) ./ spat_n2;
spat_meany2 = spat2.sumy(:) ./ spat_n2;
spat_varx2 = spat2.sumx2(:) ./ spat_n2 - spat_meanx2.^2;
spat_vary2 = spat2.sumy2(:) ./ spat_n2 - spat_meany2.^2;
spat_varx2 = max(spat_varx2, 1);
spat_vary2 = max(spat_vary2, 1);
%spat_mean2 = [spat_meanx2 spat_meany2];
%covinv2 = [1/spat_varx2 0 ; 0 1/spat_vary2];

mahalan_x = (spat_meanx1-spat_meanx2).^2 ./ (spat_varx1 + spat_varx2);
mahalan_y = (spat_meany1-spat_meany2).^2 ./ (spat_varx1 + spat_varx2);

weights = exp(-0.5 .*  (mahalan_x + mahalan_y));
% covinv = covinv1 + covinv2;
% weights = exp(-0.5 * (spat_mean1' * covinv * spatmean2));
psi = (min(spat1.histogram(:), spat2.histogram(:)) ./ sum(spat1.histogram(:)));  % note:  histogram intersection is not symmetric wrt both histograms
%similarity = sum(weights .* psi);
similarity = sum(psi);

% 
%     
%     
% meanmodel = model_spatiogram.sumx ./ model_spatiogram.histogram;
% varmodel = model_spatiogram.sumx2 ./ model_spatiogram.histogram - meanmodel.^2;
% 
% meancurrent = spatiogram.sumx ./ spatiogram.histogram;
% varcurrent = spatiogram.sumx2 ./ spatiogram.histogram - meancurrent.^2;
% 
% covar =1/2((1/varcurrent) + (1/varmodel));
% 
% 
% weighingfn = exp(sum((meancurrent - meanmodel)'*covar(meanmodel - meancurrent))); % Not sure if weighing function is right