% remove ellipse from images
if 0,
    for i=500,
        im = double(imread(sprintf('seq_sb/img%03d.bmp', i)));
        [r,g,b] = remove_ellipse(im(:,:,1), im(:,:,2), im(:,:,3));
        foo(:,:,1) = r;    
        foo(:,:,2) = g;    
        foo(:,:,3) = b;
        imwrite(uint8(foo), sprintf('seq_sb/imgnoellipse%03d.bmp', i));
    end
end

% use histogram and spatiogram as generative models
if 0,
    sz = [26 26 26 26];
%    frames = [79 85 88 93 98];
    frames = [79 85 88 500];
    for i=1:4,
        frame = frames(i);
%        i=0;
        % read image and initialize ellipse manually
        im = double(imread(sprintf('c:/stb/data/seq_sb/imgnoellipse%03d.bmp', frame)));
        figure(1), clf, imagesc(uint8(im))
		[state(2) state(1)] = ginput(1);
		state(3) = sz(i);
%		state(3) = 23;
        aspect_ratio = 1.2;
        show_ellipse_overlayed(im, state, aspect_ratio);
	
        % create perimeter and mask for ellipse
        [ellipse_perimeter, ellipse_mask] = generate_ellipse(size(im), state, aspect_ratio)
%        ellipse_perimeter = ellipse(state, aspect_ratio);
%        ellipse_mask = create_ellipse_binary_mask(im, ellipse_perimeter);
	
        % show image quantized with histogram bins, and new image obtained
        % using histogram as generative model, and new image obtained
        % using spatiogram as generative model
        nbins = [8 8 8];
        newim1 = quantize_image_using_histogram_bins(im, nbins);
        newim2 = generate_image_from_histogram_of_image(im, state, aspect_ratio, nbins);
        newim3 = generate_image_from_spatiogram_of_image(im, state, aspect_ratio, nbins);
        for j=1:3,
            newim1(:,:,j) = newim1(:,:,j) .* ellipse_mask + 255*(1-ellipse_mask);        
            newim2(:,:,j) = newim2(:,:,j) .* ellipse_mask + 255*(1-ellipse_mask);        
            newim3(:,:,j) = newim3(:,:,j) .* ellipse_mask + 255*(1-ellipse_mask);        
        end
        xmin = state(2)-state(3);
        xmax = state(2)+state(3);
        ymin = state(1)-round(state(3)*aspect_ratio);
        ymax = state(1)+round(state(3)*aspect_ratio);
        figure(1), clf, imagesc(uint8(newim1)), axis('equal'), axis([xmin xmax ymin ymax]), axis('off')
        figure(2), clf, imagesc(uint8(newim2)), axis('equal'), axis([xmin xmax ymin ymax]), axis('off')
        figure(3), clf, imagesc(uint8(newim3)), axis('equal'), axis([xmin xmax ymin ymax]), axis('off')
        if 1,
            figure(1), eval(sprintf('print -depsc ../fig/head%d_orig', frame));
            figure(2), eval(sprintf('print -depsc ../fig/head%d_hist', frame));
            figure(3), eval(sprintf('print -depsc ../fig/head%d_spat', frame));
        end
    end
end

if 0,
    % Track using spatiograms or histograms
    main_meanshift_spatiogram
end

% old, doesn't work too well b/c too small of a resolution
% if 0,
%     sz = [19 12 13 13];
%     frames = [0 17 22 28];
%     for i=1:4,
%         frame = frames(i);
% %        i=0;
%         % read image and initialize ellipse manually
%         im = double(imread(sprintf('seq_sb/imgnoellipse%03d.bmp', frame)));
%         figure(1), clf, imagesc(uint8(im))
% 		[state(1) state(2)] = ginput(1);
% 		state(3) = sz(i);
% 		state(3) = 19;
%         aspect_ratio = 1.2;
%         show_ellipse_overlayed(im, state, aspect_ratio);
% 	
%         % create perimeter and mask for ellipse
%         ellipse_perimeter = ellipse(state, aspect_ratio);
%         ellipse_mask = create_ellipse_binary_mask(im, ellipse_perimeter);
% 	
%         % show image quantized with histogram bins, and new image obtained
%         % using histogram as generative model, and new image obtained
%         % using spatiogram as generative model
%         nbins = [8 8 8];
%         newim1 = quantize_image_using_histogram_bins(im, nbins);
%         newim2 = generate_image_from_histogram_of_image(im, state, aspect_ratio, nbins);
%         newim3 = generate_image_from_spatiogram_of_image(im, state, aspect_ratio, nbins);
%         for j=1:3,
%             newim1(:,:,j) = newim1(:,:,j) .* ellipse_mask + 255*(1-ellipse_mask);        
%             newim2(:,:,j) = newim2(:,:,j) .* ellipse_mask + 255*(1-ellipse_mask);        
%             newim3(:,:,j) = newim3(:,:,j) .* ellipse_mask + 255*(1-ellipse_mask);        
%         end
%         xmin = state(1)-state(3);
%         xmax = state(1)+state(3);
%         ymin = state(2)-round(state(3)*aspect_ratio);
%         ymax = state(2)+round(state(3)*aspect_ratio);
%         figure(1), clf, imagesc(uint8(newim1)), axis([xmin xmax ymin ymax]), axis('equal'), axis('off')
%         figure(2), clf, imagesc(uint8(newim2)), axis([xmin xmax ymin ymax]), axis('equal'), axis('off')
%         figure(3), clf, imagesc(uint8(newim3)), axis([xmin xmax ymin ymax]), axis('equal'), axis('off')
%         if 1,
%             figure(1), eval(sprintf('print -depsc head%d_orig', frame));
%             figure(2), eval(sprintf('print -depsc head%d_hist', frame));
%             figure(3), eval(sprintf('print -depsc head%d_spat', frame));
%         end
%     end
% end

% show results
if 0,
%    load results
    stathist = states_hist_sb_1_100_colspace;
    statspat = states_spat_sb_1_100_colspace;
    fname_base = 'c:/stb/data/seq_sb/imgnoellipse%03d.bmp';
    for i=[0, 2:5:37, 42,43],
%    for i=0:50,
%        i
        im = imread(sprintf(fname_base, i));
        im = double(im);
        figure(2)
        s1 = stathist(i+1,:);
        s2 = statspat(i+1,:);
        out = show_ellipse_overlayed2(im, s1, s2, aspect_ratio);
        out = uint8(out);
        axis off
        eval(['print -depsc ' sprintf('meanshift%03d', i)]);
%        imwrite(out, sprintf('out%03d.bmp', i));
%        pause(1)
    end
end

%     % create perimeter and mask for ellipse
%     ellipse_perimeter = ellipse(state, aspect_ratio);
%     % (note:  you must manually ensure that the image size in 
%     % create_ellipse_binary_mask is correct, or else your mask won't be the
%     % right size; the intersection code should still work, but for display
%     % purposes it will look awkward.
%     ellipse_mask = create_ellipse_binary_mask(im, ellipse_perimeter);
%     for i=1:3,
%         fooim(:,:,i) = im(:,:,i) .* ellipse_mask;
%     end
%     figure(1), clf, imagesc(uint8(fooim))
% %    figure(2), clf, imagesc(double(ellipse_mask)), colormap(gray)
% 
%     nbins = [4 8 8];
% %    nbins = [16 16 16];
% %    nbins = [32 32 32];
%     
%     % compute color histogram
%     hist = compute_color_histogram(im, state, aspect_ratio, nbins);
%     
%     % generate cdf of histogram
%     histee = hist(:);
%     histee = histee / sum(histee);  % make it a pdf
%     hcdf = zeros(size(histee));
%     hcdf(1) = histee(1);  
%     for i=2:length(histee),
%         hcdf(i) = hcdf(i-1) + histee(i);
%     end
%     
%     % generate new image using histogram as generative model
%     % (i.e., by randomly sampling cdf of histogram)
%     newim = zeros(size(im));
%     doprint = 1;
%     for i=1:size(newim,1),
%         for j=1:size(newim,2),
%             % find bin(s) closest to a random sampling of cdf
%             diff = abs(hcdf-rand(1));
%             ii = find(diff == min(diff));
%             indx = ii(1);
%             % get color of 'indx' bin in the histogram
%             indx3 = floor((indx-1) / (nbins(1)*nbins(2))) + 1;
%             leftover = mod((indx-1), nbins(1)*nbins(2));
%             indx2 = floor(leftover / nbins(1)) + 1;
%             indx1 = mod(leftover, nbins(1)) + 1;
% 			binwidth1 = 256/nbins(1);
% 			binwidth2 = 256/nbins(2);
% 			binwidth3 = 256/nbins(3);
%             color1 = binwidth1 * ( indx1 - 0.5);
%             color2 = binwidth2 * ( indx2 - 0.5);
%             color3 = binwidth3 * ( indx3 - 0.5);
%             if doprint & (color1>255 | color2>255 | color3>255),
%                 [indx indx1 indx2 indx3 binwidth1 binwidth2 binwidth3 color1 color2 color3]
%                 doprint = 0;
%                 return
%             end
%             newim(i,j,1) = color1;
%             newim(i,j,2) = color2;
%             newim(i,j,3) = color3;
%         end
%     end
%     for i=1:3,
%         newim(:,:,i) = newim(:,:,i) .* ellipse_mask;        
%     end
%    figure(4), clf, imagesc(uint8(newim))

%     hist2 = compute_color_histogram(newim, state, aspect_ratio, nbins);
%     histee2 = hist(:);
%     histee2 = histee2 / sum(histee2);  % make it a pdf
    
%     figure(5), clf, hold on
%     plot(histee,'k')
%     plot(histee2,'ro')
    %plot(hcdf,'g')
    %end

if 0,
%     % quantize image using histogram bins
%     newim = zeros(size(im));
% 	col1 = im(:,:,1);
% 	col2 = im(:,:,2);
% 	col3 = im(:,:,3);
% 	binwidth1 = 256/nbins(1);
% 	binwidth2 = 256/nbins(2);
% 	binwidth3 = 256/nbins(3);
% 	indx1 =floor( (col1-1) / binwidth1 ) + 1;
% 	indx2 =floor( (col2-1) / binwidth2 ) + 1;
% 	indx3 =floor( (col3-1) / binwidth3 ) + 1;
%     color1 = binwidth1 * ( indx1 - 0.5);
%     color2 = binwidth2 * ( indx2 - 0.5);
%     color3 = binwidth3 * ( indx3 - 0.5);
%     newim(:,:,1) = color1;
%     newim(:,:,2) = color2;
%     newim(:,:,3) = color3;
% 
%     for i=1:3,
%         newim(:,:,i) = newim(:,:,i) .* ellipse_mask;        
%     end
%     figure(3), clf, imagesc(uint8(newim))
end


%----------------------------- Note-------------------------------%
% Sriram's code for local search is under makefig/local_search_code %
% To generate images from MAT files that contain states of the ellipse for
% every frame, go to makefig/headtracker_pts and load the MAT files from
% the appropriate directory and run "figcomp.m"%